#ifndef __CmvSource_H__
#define __CmvSource_H__



//          CMVSource 1.0.0 for AviSynth 2.5.x
//
//  Loads Dwarf Fortress CMV and CCMV movies. Latest release hosted at
//  http://www.gyroshot.com/cmvsource.htm
//
//          Copyright 2011 Robert Martens  robert.martens@gmail.com
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software Foundation,
//  Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.



#include <string>
#include <vector>
#include <Windows.h>

#include "avisynth.h"



class CmvSource : public IClip
{

private:

  VideoInfo vi;
  PVideoFrame set;
  bool zlibData;
  int cmvCols, cmvRows,
      tileW, tileH,
      bytesPerPixel,
      frameSize;

  std::vector<unsigned char> frameVec, attribVec;
  std::vector<int> colors;
  
public:

  CmvSource(  std::vector<char> _cmvBuf, PClip _tileset,
              std::string _colors, int _tileW, int _tileH,
              IScriptEnvironment* env);
  ~CmvSource();

  void __stdcall GetAudio(void* buf, __int64 start, __int64 count, IScriptEnvironment* env);
  PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env);
  bool __stdcall GetParity(int n) { return false; }
  const VideoInfo& __stdcall GetVideoInfo() { return vi; }
  void __stdcall SetCacheHints(int cachehints, int frame_range) {}
  
};



#endif // __CmvSource_H__